> ## Documentation Index
> Fetch the complete documentation index at: https://docs.infercrane.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Plan a digest-pinned external artifact build



## OpenAPI

````yaml /openapi.json post /api/v1/optimized-artifacts
openapi: 3.1.0
info:
  description: >-
    Durable, authenticated control-plane operations. Mutation responses may
    outlive the requesting client.
  title: InferCrane Control API
  version: 2.0.0
servers:
  - description: Local InferCrane API and gateway
    url: http://127.0.0.1:18000
security: []
tags:
  - name: Admission
  - name: Adoption
  - name: Alerts
  - name: Async inference
  - name: Audit
  - name: Autopilot
  - name: Benchmarks
  - name: Burst Guard
  - name: Capacity intelligence
  - name: Context Passport
  - name: Deployments
  - name: Diagnostics
  - name: Endpoints
  - name: External capacity
  - name: FinOps
  - name: Identity
  - name: Inference
  - name: Inference Lab
  - name: Inference decisions
  - name: Inference optimization
  - name: Infrastructure
  - name: Model artifacts
  - name: Model catalog
  - name: Monitoring
  - name: Operations
  - name: Providers
  - name: Recipes
  - name: Release Guard
  - name: Release evidence
  - name: Replay
  - name: Revisions
  - name: Routing
  - name: Sandboxes
  - name: Scaling
  - name: Secrets
  - name: System
  - name: Targets
  - name: Training lineage
paths:
  /api/v1/optimized-artifacts:
    post:
      tags:
        - Inference optimization
      summary: Plan a digest-pinned external artifact build
      operationId: createOptimizedArtifact
      parameters:
        - description: >-
            Stable key used to adopt the original durable operation after
            retries or disconnects.
          in: header
          name: Idempotency-Key
          required: true
          schema:
            maxLength: 128
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/OptimizedArtifactPlan'
        required: true
      responses:
        '201':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Object'
          description: Created
        default:
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorEnvelope'
          description: Typed API error
      security:
        - bearerAuth: []
components:
  schemas:
    OptimizedArtifactPlan:
      additionalProperties: false
      properties:
        algorithm:
          minLength: 1
          type: string
        base_model_artifact_id:
          minLength: 1
          type: string
        builder_image_digest:
          pattern: ^sha256:[a-fA-F0-9]{64}$
          type: string
        calibration_digest:
          pattern: ^sha256:[a-fA-F0-9]{64}$
          type: string
        configuration:
          type: object
        format:
          minLength: 1
          type: string
        hardware_constraints:
          type: object
        kind:
          enum:
            - quantized_checkpoint
            - speculator_checkpoint
            - tensorrt_engine
          type: string
        license_spdx:
          minLength: 1
          type: string
        requires_quality_review:
          const: true
          type: boolean
        tool:
          enum:
            - llm-compressor
            - modelopt
            - vllm-speculators
            - tensorrt-llm
          type: string
        tool_version:
          minLength: 1
          type: string
      required:
        - base_model_artifact_id
        - kind
        - format
        - tool
        - tool_version
        - algorithm
        - builder_image_digest
        - license_spdx
        - configuration
        - hardware_constraints
        - requires_quality_review
      type: object
    Object:
      additionalProperties: true
      type: object
    ErrorEnvelope:
      properties:
        error:
          $ref: '#/components/schemas/Error'
      required:
        - error
      type: object
    Error:
      properties:
        category:
          type: string
        code:
          type: string
        message:
          type: string
        remediation:
          type: string
        request_id:
          type: string
        retryable:
          type: boolean
      required:
        - code
        - message
      type: object
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http

````